// select the pins used on the LCD panel
#include <LiquidCrystal.h>

LiquidCrystal lcd(8, 9, 4, 5, 6, 7);

// define some values used by the panel and buttons
int lcd_key     = 0;
int adc_key_in  = 0;
#define btnRIGHT  0
#define btnUP     1
#define btnDOWN   2
#define btnLEFT   3
#define btnSELECT 4
#define btnNONE   5

void setup() {
  // put your setup code here, to run once:
  pinMode(13, OUTPUT);  //Configure the LED pin as an output, pin 13 is the onboard LED

  lcd.begin(16, 2);              // start the library
  lcd.setCursor(2,0);
  lcd.print("JvZ Digital"); // print a simple message
  lcd.setCursor(3,1);
  lcd.print("Sourcing"); // print a simple message
}

int read_LCD_buttons()
{
 adc_key_in = analogRead(0);      // read the value from the sensor 
 // my buttons when read are centered at these valies: 0, 144, 329, 504, 741
 // we add approx 50 to those values and check to see if we are close
 if (adc_key_in > 1000) return btnNONE; // We make this the 1st option for speed reasons since it will be the most likely result
 // For V1.1 us this threshold
 if (adc_key_in < 50)   return btnRIGHT;  
 if (adc_key_in < 250)  return btnUP; 
 if (adc_key_in < 450)  return btnDOWN; 
 if (adc_key_in < 650)  return btnLEFT; 
 if (adc_key_in < 850)  return btnSELECT;  
 
 return btnNONE;  // when all others fail, return this...
}

void loop() 
{
  // put your main code here, to run repeatedly:  
  digitalWrite(13, HIGH);
  lcd.setCursor(0,1);            // move to the begining of the second line
  lcd_key = read_LCD_buttons();  // read the buttons

  switch (lcd_key)               // depending on which button was pushed, we perform an action
  {
    case btnRIGHT:
    {
      lcd.print("Last Key:RIGHT ");
      break;
    }
    case btnLEFT:
    {
      lcd.print("Last Key:LEFT   ");
      break;
    }
    case btnUP:
    {
      lcd.print("Last Key:UP    ");
      break;
    }
    case btnDOWN:
    {
      lcd.print("Last Key:DOWN  ");
      break;
    }
    case btnSELECT:
    {
      lcd.print("Last Key:SELECT");
      break;
    }
    case btnNONE:
    {
      //lcd.print("NONE  ");
      break;
    }
  }
}
